#include "register_types.h"

#include "gdexample.h"


void register_types(godot::ModuleInitializationLevel p_level)
{
	using namespace godot;

	if (p_level != MODULE_INITIALIZATION_LEVEL_SCENE)
		return;

	ClassDB::register_class<SE::GDExample>();
}

void unregister_types(godot::ModuleInitializationLevel p_level)
{
	using namespace godot;

	if (p_level != MODULE_INITIALIZATION_LEVEL_SCENE)
		return;

	// Nothing for now...
}

extern "C" 
{
	GDNativeBool GDN_EXPORT 
	SENative_Init(
		GDNativeInterface const* 				p_interface, 
		GDNativeExtensionClassLibraryPtr const 	p_library, 
		GDNativeInitialization* 				r_initialization) 
	{
		using namespace godot;

		GDExtensionBinding::InitObject 
		init_obj(p_interface, p_library, r_initialization);
		init_obj.register_initializer(register_types);
		init_obj.register_terminator(unregister_types);
		init_obj.set_minimum_library_initialization_level(MODULE_INITIALIZATION_LEVEL_SCENE);

		return init_obj.init();
	}
}

